gui/config/routes.rb
Smr::Application.routes.draw do

  root :to => 'asset#index'

  resources :asset
  get  '/asset/show_portfolio/:id_portfolio', :to=>'asset#index', :as=>'show_portfolio'
  post '/asset/show_portfolio/',              :to=>'asset#index', :as=>'show_portfolio_post'

  resources :order
  resources :report
  resources :cashflow
  resources :watchlist
  resources :figures
  resources :quoterecords
  resources :quoterecord_threshold
  resources :quoterecord_rules

  post "set_session_params" => "application#set_session_params"

  get 'logout' => 'sessions#destroy', :as => 'logout'
  get 'login' => 'sessions#new', :as => 'login'
  resources :sessions
  resources :password_reset

  resources :position
  post 'execute_order', to: 'position#execute_order'
  post 'cancel_order', to: 'position#cancel_order'
  post 'patch_position', to: 'position#patch'
  get 'close', to: 'position#close'

  get '/workdesk/add',      :to=>'workdesk#add',  :as=>'workdesk_add'
  get '/workdesk/:id/drop', :to=>'workdesk#drop', :as=>'workdesk_drop'
  resources :workdesk

  resources :portrait
  get '/portrait/organization/:id', :to=>'portrait#show_organization', :as=>'portrait_organization'
  get '/portrait/security/:id',     :to=>'portrait#show_security',     :as=>'portrait_security'

  resources :cashposition
  get '/cashposition/:id/settle', :to=>'cashposition#settle', :as=>'settle_cashposition'

  resources :documents
  get 'download' => 'documents#download'
  get 'delete_document' => 'documents#delete_document'

  resources :blog
  get 'blog' => 'blog#index'

  get 'objects' => 'objects#index'
  namespace 'objects' do
      resources :organization, :security, :bookmark, :portfolio, :figurevar, :user
      post 'patch_portfolio', to: 'portfolio#patch'
  end
  get '/objects/security/:id/delete', :to=>'objects/security#destroy', :as=>'delete_security'
  get '/objects/export/securities',   :to=>'objects/security#export',  :as=>'export_securities'
  get '/objects/bookmark/:id/delete', :to=>'objects/bookmark#destroy', :as=>'delete_bookmark'

  resources :doc, :only=>:get_file
  get "/doc/:file_or_folder", :controller=>:documentation, :action=>:get_file, :file_or_folder=>/.*/
end

gui/app/models/quoterecord.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#
class Quoterecord < ActiveRecord::Base
    include Smr::Extensions::DateTimeWrapper

	belongs_to :User, :foreign_key=>:id_user
	belongs_to :Quote, :foreign_key=>:id_quote
	belongs_to :Security, :foreign_key=>:id_security
	has_one    :Organization, :through => :Security

    ##
    # possible values for 'column' field
    #
    # keys of this hash are the actual column values while the hash values are
    # a human readable representation
    # <b>ATTENTION</b>: the order matters for viewing
    POSSIBLE_COLUMNS = {
        'secondary_rally'    => 'Secondary Rally',
        'natural_rally'      => 'Natural Rally',
        'upward'             => 'Upward Trend',
        'downward'           => 'Downward Trend',
        'natural_reaction'   => 'Natural Reaction',
        'secondary_reaction' => 'Secondary Reaction',
    }

    # data validations
    validates :id_user, :id_security, :id_quote, presence: true
    validates :id_user, :id_security, :id_quote, :date_created, numericality: { greater_than: 0 }
    validates :column, inclusion: { in: POSSIBLE_COLUMNS.keys, message: "%{value} is not a valid column name" }

    # define scopes and ransack aliases for finding things
    ransack_alias :ransackcolumns, :comment_or_Security_brief_or_Security_symbol_or_Organization_name

    ##
    # returns array of possible values for :column field
    def self.get_columns
        POSSIBLE_COLUMNS.keys
    end

    ##
    # returns human readable +String+ for given column name, see get_columns()
    def self.translate_column(column=self.column)
        POSSIBLE_COLUMNS[column]
    end

    ##
    # tell whether this record has been sorted in to column
    def is_column?(column_name)
        self.column == column_name
    end

    ##
    # tell a human what happened
    def to_s
        msg = Array.new
        msg << 'UP hit' if self.is_uphit
        msg << 'DOWN hit' if self.is_downhit 
        msg << 'classified quote' if msg.empty?

        msg << 'on %s' % self.Security.to_s

        msg << 'into %s column' % self.class.translate_column(self.column)

        msg << 'which is a pivotal point' if self.is_pivotal_point
        msg << 'and triggered SIGNAL' if self.is_signal

        msg.join(' ')
    end
end

gui/app/controllers/quoterecords_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#
require 'quoterecords'

##
# Quote Records are a way of ordering market quotes into trends and putting
# personal notes on them. Interpretation of events that is.
class QuoterecordsController < ApplicationController

    ##
    # Obtains SmrQuoterecords collection.
    def index
        smr_menu_addsubitem('quote records', {
            'rules'=>:quoterecord_rules,
            '+ quote'=>:new_quoterecord,
        })

        @securities = smr_securities_list
        if params[:id_security] and params[:id_security].to_i>1 then
            session[:quoterecords_security_index] = @securities.index{|s|s.id==params[:id_security].to_i}
        else i = 0 end

        case params[:show]
            when 'previous' then session[:quoterecords_security_index] -= 1
            when 'next' then session[:quoterecords_security_index] += 1
        end
        session[:quoterecords_security_index]  = 0 if not (0..@securities.count-1) === session[:quoterecords_security_index]
        @selected_security = @securities[ session[:quoterecords_security_index]  ]

        @intraday_quotes = Quote.where(:id_security=>@selected_security.id, :date_last=>smr_browse_date.beginning_of_day.to_i..smr_browse_date.end_of_day.to_i).order(:date_last=>:desc)
        @quoterecords, @total_pages = smr_paginate(
            @page = smr_page,
            Smr::Quoterecords.new(current_user.id, @selected_security, smr_browse_date)
        )
        @sensitivity = QuoterecordThreshold.where(:id_user=>current_user.id, :id_security=>@selected_security.id).first || (QuoterecordThreshold.new(:id_security=>@selected_security.id))

        @possible_columns = Hash.new
        Quoterecord.get_columns.collect do |c|
            @possible_columns[Quoterecord.translate_column(c)] = c
        end
    end

    ##
    # handle new Quote data
    def new
        self.index
        @quote = Quote.new(:date_last=>Time.now.to_i)
        render :index
    end

    ##
    # handles creates and updates
    def create
        if params[:quoterecord][:id].to_i > 0 then
            qr = Quoterecord.where(:id=>params[:quoterecord][:id], :id_user=>current_user.id).first
            qr.update(quoterecord_params)
        else
            qr = Quoterecord.new(quoterecord_params)
            qr.id_user = current_user.id
            qr.date_created = Time.now.to_i
            qr.save!
        end

        index
        render :index
    end

    ##
    # present exiting Quoterecord for editing.
    def show
        index
        @quoterecord = Quoterecord.where(:id=>params[:id], :id_user=>current_user.id).first
        render :index
    end

    ##
    # View QuoterecordRule.
    def view_rules
        redirect_to :back
    end


    protected

    ##
    # internal helper defining parameters acceptable for quoterecord
    def quoterecord_params
      params.require(:quoterecord).permit(
        :id_security, :id_quote, :column, :comment, :is_pivotal_point, :is_uphit,
        :is_downhit, :is_signal
      )
    end
end

gui/app/helpers/quoterecords_helper.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#

##
# Collection of helper methods related to Quoterecord objects.
module QuoterecordsHelper

    ##
    # CSS class reflecting the state of :quoterecord.
    #
    # Its +nil+ if there is nothing special about that record or if the
    # record does not belong to :current_column
    #
    # Possible classes are +pivotalpoint+, +signal+, +uphit+ and +downhit+ as
    # well as any combination of them, separated by space.
    def make_css_class(quoterecord, current_column)
        raise 'quoterecord must be a Quoterecord' unless quoterecord.is_a?(Quoterecord)

        return nil unless quoterecord.is_column?(current_column)

        klass = Array.new
        klass << 'pivotalpoint' if quoterecord.is_pivotal_point
        klass << 'signal' if quoterecord.is_signal
        klass << 'uphit' if quoterecord.is_uphit
        klass << 'downhit' if quoterecord.is_downhit

        klass.join(' ') || nil
    end

end

gui/app/views/quoterecords/_form.html.erb
<% skip_fieldset = false if not skip_fieldset %>

<%= form_for quoterecord, :url=>{action: "create"}, :method=>:POST do |f| %>
 <% if not skip_fieldset %>
  <fieldset id='quoterecord'>
    <legend><% if f.object.id  %>Edit <% else %>Add new<% end %>Quote Record<%= if f.object.id then ' #%i'%f.object.id end %></legend>
    <% if f.object.id  %><span><b><%= f.object.Quote.last %></b> on <%= smr_humanize f.object.Quote.time_last %></span><% end %>
 <% end %>
    <%= f.hidden_field :id %>
    <%= f.hidden_field :id_security %>
    <%= f.hidden_field :id_quote %>
    <%= f.select :column, Quoterecord.get_columns.collect{|c| [Quoterecord.translate_column(c), c] }, :prompt=>'-- Select Column --' %>
    <%= f.text_field :comment, placeholder: 'Comment' %>
    <%= f.check_box :is_pivotal_point %><%= f.label :is_pivotal_point, 'Pivotal Point' %>
    <%= f.check_box :is_uphit %><%= f.label :is_uphit, 'UP hit' %>
    <%= f.check_box :is_downhit %><%= f.label :is_downhit, 'DOWN hit' %>
    <%= f.check_box :is_signal %><%= f.label :is_signal, 'Signal' %>
    <%= f.submit (if f.object.id then 'save' else 'record this one' end) %>
 <% if not skip_fieldset %>
  </fieldset>
 <% end %>
<% end %>

gui/app/views/quoterecords/index.html.erb
<h1>
 Quote Records
 <% if @selected_security %><em>on <%=@selected_security%></em><% end %>
</h1>

<%= render :partial=>'portrait/smart_links', locals: { :item_to_portrait=>@selected_security, :shown_is=>:quoterecords } %>

<% if @quote %>
    <%= render :partial=>'asset/quote_form', locals: { :quote=>@quote, :securities=>@securities, :selected_security=>@selected_security.id } %>
<% end %>

<%= form_tag({:action=>'index'}, :method=>:get, :id=>'controller_filter') do %>
    <p>
     <%= select_tag 'id_security', options_from_collection_for_select(@securities, :id, :to_s_with_symbol, @selected_security.id), prompt: '-- Select Security --' %>
     <%= button_tag 'show', :name=>'show', :value=>'this' %>
     <%= button_tag '<= previous', :name=>'show', :value=>'previous' %>
     <%= button_tag 'next =>', :name=>'show', :value=>'next' %>
    </p>
<% end %>

<% if not @intraday_quotes.empty? and @quoterecords.empty? or not (@quoterecords.empty? ? false : @quoterecords.first.Quote.time_last.between?(smr_browse_date.beginning_of_day, smr_browse_date.end_of_day))  %>
<h2>Observations
<em>intraday quotes in contrast to previous records</em></h2>
<table id='quoterecord_observations'>
  <% @intraday_quotes.each do |q| %>
    <tr>
        <td>
            <b><%=q.last%></b> at <%=q.time_last.strftime('%H:%M')%>
            <%if q.volume%>, <%= smr_humanize(q.volume, :shortword=>true) %> shares traded<%end%>
        </td>
        <td>
          <% # build new Quoterecord as suggestion
            msg, newqr = @quoterecords.inspect_quote(q)
            newqr.id_quote = q.id
            newqr.column = @quoterecords.get_last_recorded_column
          %>
          <% if not msg.empty? %>
            <span><%= msg %></span>
          <% end %>
          <%= render :partial=>'form', locals: { :quoterecord=>newqr, :skip_fieldset=>true } %>
        </td>
    </tr>
  <% end %>
</table>
<% end %>

<% unless @quoterecords.empty? %>
<h2>Previous Records</h2>

<% if @quoterecord %>
    <%= render :partial=>'form', locals: { :quoterecord=>@quoterecord } %>
<% end %>

<table id='quoterecords'>
    <thead>
        <tr><th colspan="7"><%= smr_paginate @page, @total_pages, quoterecords_path %></th></tr>
        <tr>
            <th/>
          <% Smr::Quoterecords.get_columns.each do |c| %>
            <th><%= Smr::Quoterecords.translate_column(c) %></th>
          <% end %>
        </tr>
        <tr>
            <td/>
          <% Smr::Quoterecords.get_columns.each do |c| %>
            <th><%= @quoterecords.get_pivot_point(c) %></th>
          <% end %>
        </tr>
    </thead>
    <tbody>
     <% @quoterecords.each do |qr| %>
        <tr>
            <td>
                <%=link_to '+', qr if qr.time_created > 90.days.ago %>
                <%=smr_humanize(qr.Quote.time_last)%>
                <% if not qr.comment.empty? %><span class="comment_text"><%=qr.comment%></span><% end %>
            </td>
          <% Smr::Quoterecords.get_columns.each do |c| %>
            <td class="<%= make_css_class(qr, c) %>">
                <%if qr.is_column?(c) %>
                    <%= qr.Quote.last %>
                    <%if qr.Quote.volume%><span><%=smr_humanize(qr.Quote.volume, :shortword=>true)%> shares traded</span><%end%>
                <%end%>
            </td>
          <% end %>
        </tr>
     <% end %>
    </tbody>
</table>
<% end %>

<h2>Sensitivity Settings</h2>
<%= form_for @sensitivity, :url=>{controller: :quoterecord_threshold, action: :create}, :method=>:POST do |f| %>
<fieldset id='quoterecord_sensitivity'>
  <legend>adjust when UP/DOWN or Pivot Point hits are triggered</legend>
    <%= hidden_field_tag :id, @sensitivity.id %>
    <%= f.hidden_field :id_security %>
    <%= f.number_field :quote_sensitivity, :step=>0.01, :min=>0.01 %> <%= f.label :quote_sensitivity, 'UP/DOWN hit sensitivity' %><br/>
    <%= f.number_field :hit_sensitivity, :step=>0.01, :min=>0.01 %> <%= f.label :hit_sensitivity, 'Pivot Point hit sensitivity' %><br/>
    <%= f.submit 'save' %>
</fieldset>
<% end %>

<br/>